from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Int, Boolean, File, String

Hal2Fasta_V0_1_0 = CommandToolBuilder(tool="hal2fasta", base_command=["hal2fasta"], inputs=[ToolInput(tag="in_cache_bytes", input_type=Int(optional=True), prefix="--cacheBytes", doc=InputDocumentation(doc=":   maximum size in bytes of regular hdf5 cache [default =\n15728640]")), ToolInput(tag="in_cache_mdc", input_type=Int(optional=True), prefix="--cacheMDC", doc=InputDocumentation(doc=":     number of metadata slots in hdf5 cache [default = 113]")), ToolInput(tag="in_cacher_dc", input_type=Int(optional=True), prefix="--cacheRDC", doc=InputDocumentation(doc=":     number of regular slots in hdf5 cache.  should be a prime\nnumber ~= 10 * DefaultCacheRDCBytes / chunk [default =\n599999]")), ToolInput(tag="in_cache_w_zero", input_type=Int(optional=True), prefix="--cacheW0", doc=InputDocumentation(doc=":      w0 parameter fro hdf5 cache [default = 0.75]")), ToolInput(tag="in_in_memory", input_type=Boolean(optional=True), prefix="--inMemory", doc=InputDocumentation(doc=":             load all data in memory (and disable hdf5 cache) [default =\n0]")), ToolInput(tag="in_length", input_type=Int(optional=True), prefix="--length", doc=InputDocumentation(doc=":       length of the reference genome (or sequence if specified) to\nconvert.  If set to 0, the entire thing is converted [default\n= 0]")), ToolInput(tag="in_linewidth", input_type=Int(optional=True), prefix="--lineWidth", doc=InputDocumentation(doc=":    Line width for output [default = 80]")), ToolInput(tag="in_out_f_a_path", input_type=File(optional=True), prefix="--outFaPath", doc=InputDocumentation(doc=":    output fasta file (stdout if none) [default = stdout]")), ToolInput(tag="in_sequence", input_type=String(optional=True), prefix="--sequence", doc=InputDocumentation(doc=":     sequence name to export (all sequences by default) [default =\n'']")), ToolInput(tag="in_start", input_type=Int(optional=True), prefix="--start", doc=InputDocumentation(doc=":        coordinate within reference genome (or sequence if specified)\nto start at [default = 0]\n")), ToolInput(tag="in_in_hal_path", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_genome", input_type=String(), position=1, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_out_f_a_path", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out_f_a_path", type_hint=File()), doc=OutputDocumentation(doc=":    output fasta file (stdout if none) [default = stdout]"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Hal2Fasta_V0_1_0().translate("wdl", allow_empty_container=True)

